
;; define some metaclass

(defclass tracked-class (standard-class) ())

#+sbcl
(defmethod sb-mop:validate-superclass ((class tracked-class) (superclass standard-class)) t)

#+ccl
(defmethod CCL:validate-superclass ((class tracked-class) (superclass standard-class)) t)

;; Try to trace access to slots through MOP

#+sbcl
(defmethod sb-mop::slot-value-using-class :before ((class tracked-class) instance slot-name)
  (format t "~&In slot-value-using-class: class = ~S, instance = ~S, slot-name = ~S.~%" class instance slot-name)
  (finish-output))

#+allegro
(defmethod mop::slot-value-using-class :before ((class tracked-class) instance slot-name)
  (format t "~&In slot-value-using-class: class = ~S, instance = ~S, slot-name = ~S.~%" class instance slot-name)
  (finish-output))

#+lispworks
(defmethod clos::slot-value-using-class :before ((class tracked-class) instance slot-name)
  (format t "~&In slot-value-using-class: class = ~S, instance = ~S, slot-name = ~S.~%" class instance slot-name)
  (finish-output))

#+clisp
(defmethod clos::slot-value-using-class :before ((class tracked-class) instance slot-name)
  (format t "~&In slot-value-using-class: class = ~S, instance = ~S, slot-name = ~S.~%" class instance slot-name)
  (finish-output))

#+(or ecl mkcl)
(defmethod clos::slot-value-using-class :before ((class tracked-class) instance slot-name)
  (format t "~&In slot-value-using-class: class = ~S, instance = ~S, slot-name = ~S.~%" class instance slot-name)
  (finish-output))

#+ccl
(defmethod CCL:slot-value-using-class :before ((class tracked-class) instance slot-name)
  (format t "~&In slot-value-using-class: class = ~S, instance = ~S, slot-name = ~S.~%" class instance slot-name)
  (finish-output))


;; define and instantiate some class

(defclass foo ()
  ((a :accessor foo-a :initarg :a)
   (b :accessor foo-b :initarg :b))
  (:metaclass tracked-class))

(defvar it (make-instance 'foo :a 1 :b 2))




;; See if tracing works. Do we get anything written to *standard-output*?

(foo-a it)
(slot-value it 'b)

